diff --git a/src/widgets/kernel/qaction.h b/src/widgets/kernel/qaction.h
index f7693f4dde..725461f546 100644
--- a/src/widgets/kernel/qaction.h
+++ b/src/widgets/kernel/qaction.h
@@ -41,11 +41,11 @@
 #define QACTION_H
 
 #include <QtWidgets/qtwidgetsglobal.h>
+#include <QtGui/qguiaction.h>
 #include <QtGui/qkeysequence.h>
 #include <QtCore/qstring.h>
 #include <QtWidgets/qwidget.h>
 #include <QtCore/qvariant.h>
-#include <QtGui/qicon.h>
 
 QT_BEGIN_NAMESPACE
 
@@ -57,121 +57,25 @@ class QActionGroup;
 class QActionPrivate;
 class QGraphicsWidget;
 
-class Q_WIDGETS_EXPORT QAction : public QObject
+class Q_WIDGETS_EXPORT QAction : public QGuiAction
 {
     Q_OBJECT
     Q_DECLARE_PRIVATE(QAction)
-
-    Q_PROPERTY(bool checkable READ isCheckable WRITE setCheckable NOTIFY changed)
-    Q_PROPERTY(bool checked READ isChecked WRITE setChecked DESIGNABLE isCheckable NOTIFY toggled)
-    Q_PROPERTY(bool enabled READ isEnabled WRITE setEnabled NOTIFY changed)
-    Q_PROPERTY(QIcon icon READ icon WRITE setIcon NOTIFY changed)
-    Q_PROPERTY(QString text READ text WRITE setText NOTIFY changed)
-    Q_PROPERTY(QString iconText READ iconText WRITE setIconText NOTIFY changed)
-    Q_PROPERTY(QString toolTip READ toolTip WRITE setToolTip NOTIFY changed)
-    Q_PROPERTY(QString statusTip READ statusTip WRITE setStatusTip NOTIFY changed)
-    Q_PROPERTY(QString whatsThis READ whatsThis WRITE setWhatsThis NOTIFY changed)
-    Q_PROPERTY(QFont font READ font WRITE setFont NOTIFY changed)
-#if QT_CONFIG(shortcut)
-    Q_PROPERTY(QKeySequence shortcut READ shortcut WRITE setShortcut NOTIFY changed)
-    Q_PROPERTY(Qt::ShortcutContext shortcutContext READ shortcutContext WRITE setShortcutContext NOTIFY changed)
-    Q_PROPERTY(bool autoRepeat READ autoRepeat WRITE setAutoRepeat NOTIFY changed)
-#endif
-    Q_PROPERTY(bool visible READ isVisible WRITE setVisible NOTIFY changed)
-    Q_PROPERTY(MenuRole menuRole READ menuRole WRITE setMenuRole NOTIFY changed)
-    Q_PROPERTY(bool iconVisibleInMenu READ isIconVisibleInMenu WRITE setIconVisibleInMenu NOTIFY changed)
-    Q_PROPERTY(bool shortcutVisibleInContextMenu READ isShortcutVisibleInContextMenu WRITE setShortcutVisibleInContextMenu NOTIFY changed)
-    Q_PROPERTY(Priority priority READ priority WRITE setPriority)
-
 public:
-    // note this is copied into qplatformmenu.h, which must stay in sync
-    enum MenuRole { NoRole = 0, TextHeuristicRole, ApplicationSpecificRole, AboutQtRole,
-                    AboutRole, PreferencesRole, QuitRole };
-    Q_ENUM(MenuRole)
-    enum Priority { LowPriority = 0,
-                    NormalPriority = 128,
-                    HighPriority = 256};
-    Q_ENUM(Priority)
-    explicit QAction(QObject *parent = nullptr);
-    explicit QAction(const QString &text, QObject *parent = nullptr);
-    explicit QAction(const QIcon &icon, const QString &text, QObject *parent = nullptr);
-
+    QAction(QObject* parent = nullptr);
+    QAction(const QString &text, QObject* parent = nullptr);
+    QAction(const QIcon &icon, const QString &text, QObject* parent);
     ~QAction();
 
-    void setActionGroup(QActionGroup *group);
     QActionGroup *actionGroup() const;
-    void setIcon(const QIcon &icon);
-    QIcon icon() const;
-
-    void setText(const QString &text);
-    QString text() const;
-
-    void setIconText(const QString &text);
-    QString iconText() const;
-
-    void setToolTip(const QString &tip);
-    QString toolTip() const;
-
-    void setStatusTip(const QString &statusTip);
-    QString statusTip() const;
-
-    void setWhatsThis(const QString &what);
-    QString whatsThis() const;
-
-    void setPriority(Priority priority);
-    Priority priority() const;
 
 #if QT_CONFIG(menu)
     QMenu *menu() const;
     void setMenu(QMenu *menu);
 #endif
 
-    void setSeparator(bool b);
-    bool isSeparator() const;
-
-#if QT_CONFIG(shortcut)
-    void setShortcut(const QKeySequence &shortcut);
-    QKeySequence shortcut() const;
-
-    void setShortcuts(const QList<QKeySequence> &shortcuts);
-    void setShortcuts(QKeySequence::StandardKey);
-    QList<QKeySequence> shortcuts() const;
-
-    void setShortcutContext(Qt::ShortcutContext context);
-    Qt::ShortcutContext shortcutContext() const;
-
-    void setAutoRepeat(bool);
-    bool autoRepeat() const;
-#endif
-
-    void setFont(const QFont &font);
-    QFont font() const;
-
-    void setCheckable(bool);
-    bool isCheckable() const;
-
-    QVariant data() const;
-    void setData(const QVariant &var);
-
-    bool isChecked() const;
-
-    bool isEnabled() const;
-
-    bool isVisible() const;
-
-    enum ActionEvent { Trigger, Hover };
-    void activate(ActionEvent event);
     bool showStatusText(QWidget *widget = nullptr);
 
-    void setMenuRole(MenuRole menuRole);
-    MenuRole menuRole() const;
-
-    void setIconVisibleInMenu(bool visible);
-    bool isIconVisibleInMenu() const;
-
-    void setShortcutVisibleInContextMenu(bool show);
-    bool isShortcutVisibleInContextMenu() const;
-
     QWidget *parentWidget() const;
 
     QList<QWidget *> associatedWidgets() const;
@@ -180,30 +84,14 @@ public:
 #endif
 
 protected:
-    bool event(QEvent *) override;
     QAction(QActionPrivate &dd, QObject *parent);
-
-public Q_SLOTS:
-    void trigger() { activate(Trigger); }
-    void hover() { activate(Hover); }
-    void setChecked(bool);
-    void toggle();
-    void setEnabled(bool);
-    inline void setDisabled(bool b) { setEnabled(!b); }
-    void setVisible(bool);
-
-Q_SIGNALS:
-    void changed();
-    void triggered(bool checked = false);
-    void hovered();
-    void toggled(bool);
+    bool event(QEvent *) override;
 
 private:
     Q_DISABLE_COPY(QAction)
 
     friend class QGraphicsWidget;
     friend class QWidget;
-    friend class QActionGroup;
     friend class QMenu;
     friend class QMenuPrivate;
     friend class QMenuBar;
diff --git a/src/widgets/kernel/qaction_p.h b/src/widgets/kernel/qaction_p.h
index 6b6ca8076f..2583607e75 100644
--- a/src/widgets/kernel/qaction_p.h
+++ b/src/widgets/kernel/qaction_p.h
@@ -52,6 +52,7 @@
 //
 
 #include <QtWidgets/private/qtwidgetsglobal_p.h>
+#include <QtGui/private/qguiaction_p.h>
 #include "QtWidgets/qaction.h"
 #if QT_CONFIG(menu)
 #include "QtWidgets/qmenu.h"
@@ -68,12 +69,13 @@ QT_BEGIN_NAMESPACE
 
 class QShortcutMap;
 
-class Q_WIDGETS_EXPORT QActionPrivate : public QObjectPrivate
+class Q_WIDGETS_EXPORT QActionPrivate : public QGuiActionPrivate
 {
     Q_DECLARE_PUBLIC(QAction)
 public:
-    QActionPrivate();
-    ~QActionPrivate();
+    QActionPrivate() = default;
+
+    QShortcutMap::ContextMatcher contextMatcher() const override;
 
     static QActionPrivate *get(QAction *q)
     {
@@ -82,50 +84,11 @@ public:
 
     bool showStatusText(QWidget *w, const QString &str);
 
-    QPointer<QActionGroup> group;
-    QString text;
-    QString iconText;
-    QIcon icon;
-    QString tooltip;
-    QString statustip;
-    QString whatsthis;
-#if QT_CONFIG(shortcut)
-    QKeySequence shortcut;
-    QList<QKeySequence> alternateShortcuts;
-#endif
-    QVariant userData;
-#if QT_CONFIG(shortcut)
-    int shortcutId = 0;
-    QVector<int> alternateShortcutIds;
-    Qt::ShortcutContext shortcutContext = Qt::WindowShortcut;
-    uint autorepeat : 1;
-#endif
-    QFont font;
     QPointer<QMenu> menu;
-    uint enabled : 1, forceDisabled : 1;
-    uint visible : 1, forceInvisible : 1;
-    uint checkable : 1;
-    uint checked : 1;
-    uint separator : 1;
-    uint fontSet : 1;
-
-    int iconVisibleInMenu : 2;  // Only has values -1, 0, and 1
-    int shortcutVisibleInContextMenu : 2; // Only has values -1, 0, and 1
-
-    QAction::MenuRole menuRole = QAction::TextHeuristicRole;
-    QAction::Priority priority = QAction::NormalPriority;
-
     QWidgetList widgets;
 #if QT_CONFIG(graphicsview)
     QList<QGraphicsWidget *> graphicsWidgets;
 #endif
-#if QT_CONFIG(shortcut)
-    void redoGrab(QShortcutMap &map);
-    void redoGrabAlternate(QShortcutMap &map);
-    void setShortcutEnabled(bool enable, QShortcutMap &map);
-#endif // QT_NO_SHORTCUT
-
-    void sendDataChanged();
 };
 
 #endif // QT_NO_ACTION
diff --git a/src/widgets/kernel/qactiongroup.cpp b/src/widgets/kernel/qactiongroup.cpp
index 1d9213de0c..56e1df6b23 100644
--- a/src/widgets/kernel/qactiongroup.cpp
+++ b/src/widgets/kernel/qactiongroup.cpp
@@ -38,70 +38,34 @@
 ****************************************************************************/
 
 #include "qactiongroup.h"
+#include <QtGui/private/qguiactiongroup_p.h>
 
 #ifndef QT_NO_ACTION
 
-#include "qaction_p.h"
-#include "qevent.h"
-#include "qlist.h"
+#include "qaction.h"
 
 QT_BEGIN_NAMESPACE
 
-class QActionGroupPrivate : public QObjectPrivate
+class QActionGroupPrivate : public QGuiActionGroupPrivate
 {
     Q_DECLARE_PUBLIC(QActionGroup)
 public:
-    QActionGroupPrivate() : enabled(1),
-                            visible(1),
-                            exclusionPolicy(QActionGroup::ExclusionPolicy::Exclusive)
-    {
-    }
-    QList<QAction *> actions;
-    QPointer<QAction> current;
-    uint enabled : 1;
-    uint visible : 1;
-    QActionGroup::ExclusionPolicy exclusionPolicy;
-
-private:
-    void _q_actionTriggered();  //private slot
-    void _q_actionChanged();    //private slot
-    void _q_actionHovered();    //private slot
+     void emitSignal(Signal, QGuiAction *) override;
 };
 
-void QActionGroupPrivate::_q_actionChanged()
+void QActionGroupPrivate::emitSignal(Signal s, QGuiAction *action)
 {
     Q_Q(QActionGroup);
-    QAction *action = qobject_cast<QAction*>(q->sender());
-    Q_ASSERT_X(action != nullptr, "QActionGroup::_q_actionChanged", "internal error");
-    if (exclusionPolicy != QActionGroup::ExclusionPolicy::None) {
-        if (action->isChecked()) {
-            if (action != current) {
-                if(current)
-                    current->setChecked(false);
-                current = action;
-            }
-        } else if (action == current) {
-            current = 0;
-        }
+    switch (s) {
+    case QGuiActionGroupPrivate::Triggered:
+        emit q->triggered(static_cast<QAction *>(action));
+        break;
+    case QGuiActionGroupPrivate::Hovered:
+        emit q->hovered(static_cast<QAction *>(action));
+        break;
     }
 }
 
-void QActionGroupPrivate::_q_actionTriggered()
-{
-    Q_Q(QActionGroup);
-    QAction *action = qobject_cast<QAction*>(q->sender());
-    Q_ASSERT_X(action != nullptr, "QActionGroup::_q_actionTriggered", "internal error");
-    emit q->triggered(action);
-}
-
-void QActionGroupPrivate::_q_actionHovered()
-{
-    Q_Q(QActionGroup);
-    QAction *action = qobject_cast<QAction*>(q->sender());
-    Q_ASSERT_X(action != nullptr, "QActionGroup::_q_actionHovered", "internal error");
-    emit q->hovered(action);
-}
-
 /*!
     \class QActionGroup
     \brief The QActionGroup class groups actions together.
@@ -153,27 +117,6 @@ void QActionGroupPrivate::_q_actionHovered()
     \sa QAction
 */
 
-/*!
-    \enum QActionGroup::ExclusionPolicy
-
-    This enum specifies the different policies that can be used to
-    control how the group performs exclusive checking on checkable actions.
-
-    \value None
-           The actions in the group can be checked independently of each other.
-
-    \value Exclusive
-           Exactly one action can be checked at any one time.
-           This is the default policy.
-
-    \value ExclusiveOptional
-           At most one action can be checked at any one time. The actions
-           can also be all unchecked.
-
-    \sa exclusionPolicy
-    \since 5.14
-*/
-
 /*!
     Constructs an action group for the \a parent object.
 
@@ -182,53 +125,24 @@ void QActionGroupPrivate::_q_actionHovered()
     but allow unchecking the active action call instead
     setExclusionPolicy(QActionGroup::ExclusionPolicy::ExclusiveOptional)
 */
-QActionGroup::QActionGroup(QObject* parent) : QObject(*new QActionGroupPrivate, parent)
+QActionGroup::QActionGroup(QObject* parent) :
+    QGuiActionGroup(*new QActionGroupPrivate, parent)
 {
 }
 
 /*!
     Destroys the action group.
 */
-QActionGroup::~QActionGroup()
+QActionGroup::~QActionGroup() = default;
+
+QAction *QActionGroup::checkedAction() const
 {
+    return static_cast<QAction *>(checkedGuiAction());
 }
 
-/*!
-    \fn QAction *QActionGroup::addAction(QAction *action)
-
-    Adds the \a action to this group, and returns it.
-
-    Normally an action is added to a group by creating it with the
-    group as its parent, so this function is not usually used.
-
-    \sa QAction::setActionGroup()
-*/
-QAction *QActionGroup::addAction(QAction* a)
+QAction *QActionGroup::addAction(QAction *a)
 {
-    Q_D(QActionGroup);
-    if(!d->actions.contains(a)) {
-        d->actions.append(a);
-        QObject::connect(a, SIGNAL(triggered()), this, SLOT(_q_actionTriggered()));
-        QObject::connect(a, SIGNAL(changed()), this, SLOT(_q_actionChanged()));
-        QObject::connect(a, SIGNAL(hovered()), this, SLOT(_q_actionHovered()));
-    }
-    if(!a->d_func()->forceDisabled) {
-        a->setEnabled(d->enabled);
-        a->d_func()->forceDisabled = false;
-    }
-    if(!a->d_func()->forceInvisible) {
-        a->setVisible(d->visible);
-        a->d_func()->forceInvisible = false;
-    }
-    if(a->isChecked())
-        d->current = a;
-    QActionGroup *oldGroup = a->d_func()->group;
-    if(oldGroup != this) {
-        if (oldGroup)
-            oldGroup->removeAction(a);
-        a->d_func()->group = this;
-        a->d_func()->sendDataChanged();
-    }
+    QGuiActionGroup::addAction(a);
     return a;
 }
 
@@ -260,185 +174,19 @@ QAction *QActionGroup::addAction(const QIcon &icon, const QString &text)
     return new QAction(icon, text, this);
 }
 
-/*!
-  Removes the \a action from this group. The action will have no
-  parent as a result.
-
-  \sa QAction::setActionGroup()
-*/
-void QActionGroup::removeAction(QAction *action)
-{
-    Q_D(QActionGroup);
-    if (d->actions.removeAll(action)) {
-        if (action == d->current)
-            d->current = 0;
-        QObject::disconnect(action, SIGNAL(triggered()), this, SLOT(_q_actionTriggered()));
-        QObject::disconnect(action, SIGNAL(changed()), this, SLOT(_q_actionChanged()));
-        QObject::disconnect(action, SIGNAL(hovered()), this, SLOT(_q_actionHovered()));
-        action->d_func()->group = 0;
-    }
-}
-
 /*!
     Returns the list of this groups's actions. This may be empty.
 */
 QList<QAction*> QActionGroup::actions() const
 {
-    Q_D(const QActionGroup);
-    return d->actions;
-}
-
-/*!
-    \brief Enable or disable the group exclusion checking
-
-    This is a convenience method that calls
-    setExclusionPolicy(ExclusionPolicy::Exclusive).
-
-    \sa QActionGroup::exclusionPolicy
-*/
-void QActionGroup::setExclusive(bool b)
-{
-    setExclusionPolicy(b ? QActionGroup::ExclusionPolicy::Exclusive
-                         : QActionGroup::ExclusionPolicy::None);
-}
-
-/*!
-    \brief Returs true if the group is exclusive
-
-    The group is exclusive if the ExclusionPolicy is either Exclusive
-    or ExclusionOptional.
-
-*/
-bool QActionGroup::isExclusive() const
-{
-    return exclusionPolicy() != QActionGroup::ExclusionPolicy::None;
+    QList<QAction*> result;
+    const auto baseActions = guiActions();
+    result.reserve(baseActions.size());
+    for (auto baseAction : baseActions)
+        result.append(static_cast<QAction*>(baseAction));
+    return result;
 }
 
-/*!
-    \property QActionGroup::exclusionPolicy
-    \brief This property holds the group exclusive checking policy
-
-    If exclusionPolicy is set to Exclusive, only one checkable
-    action in the action group can ever be active at any time. If the user
-    chooses another checkable action in the group, the one they chose becomes
-    active and the one that was active becomes inactive. If exclusionPolicy is
-    set to ExclusionOptional the group is exclusive but the active checkable
-    action in the group can be unchecked leaving the group with no actions
-    checked.
-
-    \sa QAction::checkable
-    \since 5.14
-*/
-void QActionGroup::setExclusionPolicy(QActionGroup::ExclusionPolicy policy)
-{
-    Q_D(QActionGroup);
-    d->exclusionPolicy = policy;
-}
-
-QActionGroup::ExclusionPolicy QActionGroup::exclusionPolicy() const
-{
-    Q_D(const QActionGroup);
-    return d->exclusionPolicy;
-}
-
-/*!
-    \fn void QActionGroup::setDisabled(bool b)
-
-    This is a convenience function for the \l enabled property, that
-    is useful for signals--slots connections. If \a b is true the
-    action group is disabled; otherwise it is enabled.
-*/
-
-/*!
-    \property QActionGroup::enabled
-    \brief whether the action group is enabled
-
-    Each action in the group will be enabled or disabled unless it
-    has been explicitly disabled.
-
-    \sa QAction::setEnabled()
-*/
-void QActionGroup::setEnabled(bool b)
-{
-    Q_D(QActionGroup);
-    d->enabled = b;
-    for (auto action : qAsConst(d->actions)) {
-        if (!action->d_func()->forceDisabled) {
-            action->setEnabled(b);
-            action->d_func()->forceDisabled = false;
-        }
-    }
-}
-
-bool QActionGroup::isEnabled() const
-{
-    Q_D(const QActionGroup);
-    return d->enabled;
-}
-
-/*!
-  Returns the currently checked action in the group, or \nullptr if
-  none are checked.
-*/
-QAction *QActionGroup::checkedAction() const
-{
-    Q_D(const QActionGroup);
-    return d->current;
-}
-
-/*!
-    \property QActionGroup::visible
-    \brief whether the action group is visible
-
-    Each action in the action group will match the visible state of
-    this group unless it has been explicitly hidden.
-
-    \sa QAction::setEnabled()
-*/
-void QActionGroup::setVisible(bool b)
-{
-    Q_D(QActionGroup);
-    d->visible = b;
-    for (auto action : qAsConst(d->actions)) {
-        if (!action->d_func()->forceInvisible) {
-            action->setVisible(b);
-            action->d_func()->forceInvisible = false;
-        }
-    }
-}
-
-bool QActionGroup::isVisible() const
-{
-    Q_D(const QActionGroup);
-    return d->visible;
-}
-
-/*!
-    \fn void QActionGroup::triggered(QAction *action)
-
-    This signal is emitted when the given \a action in the action
-    group is activated by the user; for example, when the user clicks
-    a menu option, toolbar button, or presses an action's shortcut key
-    combination.
-
-    Connect to this signal for command actions.
-
-    \sa QAction::activate()
-*/
-
-/*!
-    \fn void QActionGroup::hovered(QAction *action)
-
-    This signal is emitted when the given \a action in the action
-    group is highlighted by the user; for example, when the user
-    pauses with the cursor over a menu option, toolbar button, or
-    presses an action's shortcut key combination.
-
-    \sa QAction::activate()
-*/
-
 QT_END_NAMESPACE
 
-#include "moc_qactiongroup.cpp"
-
 #endif // QT_NO_ACTION
diff --git a/src/widgets/kernel/qactiongroup.h b/src/widgets/kernel/qactiongroup.h
index 90f488bedb..6ec2fc09ef 100644
--- a/src/widgets/kernel/qactiongroup.h
+++ b/src/widgets/kernel/qactiongroup.h
@@ -41,6 +41,7 @@
 #define QACTIONGROUP_H
 
 #include <QtWidgets/qtwidgetsglobal.h>
+#include <QtGui/qguiactiongroup.h>
 #include <QtWidgets/qaction.h>
 
 QT_BEGIN_NAMESPACE
@@ -50,45 +51,22 @@ QT_BEGIN_NAMESPACE
 
 class QActionGroupPrivate;
 
-class Q_WIDGETS_EXPORT QActionGroup : public QObject
+class Q_WIDGETS_EXPORT QActionGroup : public QGuiActionGroup
 {
     Q_OBJECT
     Q_DECLARE_PRIVATE(QActionGroup)
 
-    Q_PROPERTY(QActionGroup::ExclusionPolicy exclusionPolicy READ exclusionPolicy WRITE setExclusionPolicy)
-    Q_PROPERTY(bool enabled READ isEnabled WRITE setEnabled)
-    Q_PROPERTY(bool visible READ isVisible WRITE setVisible)
-
 public:
-    enum class ExclusionPolicy {
-        None,
-        Exclusive,
-        ExclusiveOptional
-    };
-    Q_ENUM(ExclusionPolicy)
-
     explicit QActionGroup(QObject* parent);
     ~QActionGroup();
 
-    QAction *addAction(QAction* a);
-    QAction *addAction(const QString &text);
-    QAction *addAction(const QIcon &icon, const QString &text);
-    void removeAction(QAction *a);
-    QList<QAction*> actions() const;
-
     QAction *checkedAction() const;
-    bool isExclusive() const;
-    bool isEnabled() const;
-    bool isVisible() const;
-    ExclusionPolicy exclusionPolicy() const;
 
+    QAction *addAction(QAction *a);
+    QAction *addAction(const QString &text);
+    QAction *addAction(const QIcon &icon, const QString &text);
 
-public Q_SLOTS:
-    void setEnabled(bool);
-    inline void setDisabled(bool b) { setEnabled(!b); }
-    void setVisible(bool);
-    void setExclusive(bool);
-    void setExclusionPolicy(ExclusionPolicy policy);
+    QList<QAction*> actions() const;
 
 Q_SIGNALS:
     void triggered(QAction *);
@@ -96,9 +74,6 @@ Q_SIGNALS:
 
 private:
     Q_DISABLE_COPY(QActionGroup)
-    Q_PRIVATE_SLOT(d_func(), void _q_actionTriggered())
-    Q_PRIVATE_SLOT(d_func(), void _q_actionChanged())
-    Q_PRIVATE_SLOT(d_func(), void _q_actionHovered())
 };
 
 #endif // QT_NO_ACTION
diff --git a/src/widgets/styles/qstyleoption.cpp b/src/widgets/styles/qstyleoption.cpp
index 4faf98a0a3..ec312a1ce4 100644
--- a/src/widgets/styles/qstyleoption.cpp
+++ b/src/widgets/styles/qstyleoption.cpp
@@ -1765,7 +1765,7 @@ QStyleOptionMenuItem::QStyleOptionMenuItem(int version)
     \value Exclusive The item is an exclusive check item (like a radio button).
     \value NonExclusive The item is a non-exclusive check item (like a check box).
 
-    \sa checkType, QAction::checkable, QAction::checked, QActionGroup::exclusive
+    \sa checkType, QGuiAction::checkable, QGuiAction::checked, QGuiActionGroup::exclusive
 */
 
 /*!
diff --git a/src/widgets/widgets/qlineedit_p.cpp b/src/widgets/widgets/qlineedit_p.cpp
index 7d580e50a5..d0ca0f4922 100644
--- a/src/widgets/widgets/qlineedit_p.cpp
+++ b/src/widgets/widgets/qlineedit_p.cpp
@@ -373,7 +373,7 @@ void QLineEditIconButton::actionEvent(QActionEvent *e)
 {
     switch (e->type()) {
     case QEvent::ActionChanged: {
-        const QAction *action = e->action();
+        const auto *action = e->action();
         if (isVisibleTo(parentWidget()) != action->isVisible()) {
             setVisible(action->isVisible());
             if (QLineEditPrivate *lep = lineEditPrivate())
@@ -548,7 +548,7 @@ void QLineEditPrivate::positionSideWidgets()
     }
 }
 
-QLineEditPrivate::SideWidgetLocation QLineEditPrivate::findSideWidget(const QAction *a) const
+QLineEditPrivate::SideWidgetLocation QLineEditPrivate::findSideWidget(const QGuiAction *a) const
 {
     int i = 0;
     for (const auto &e : leadingSideWidgets) {
@@ -637,7 +637,7 @@ QWidget *QLineEditPrivate::addAction(QAction *newAction, QAction *before, QLineE
     return w;
 }
 
-void QLineEditPrivate::removeAction(QAction *action)
+void QLineEditPrivate::removeAction(QGuiAction *action)
 {
 #if QT_CONFIG(action)
     Q_Q(QLineEdit);
diff --git a/src/widgets/widgets/qlineedit_p.h b/src/widgets/widgets/qlineedit_p.h
index 3f98aab901..33483254b6 100644
--- a/src/widgets/widgets/qlineedit_p.h
+++ b/src/widgets/widgets/qlineedit_p.h
@@ -241,7 +241,7 @@ public:
     QString placeholderText;
 
     QWidget *addAction(QAction *newAction, QAction *before, QLineEdit::ActionPosition, int flags = 0);
-    void removeAction(QAction *action);
+    void removeAction(QGuiAction *action);
     SideWidgetParameters sideWidgetParameters() const;
     QIcon clearButtonIcon() const;
     void setClearButtonEnabled(bool enabled);
@@ -264,7 +264,7 @@ private:
     };
     friend class QTypeInfo<SideWidgetLocation>;
 
-    SideWidgetLocation findSideWidget(const QAction *a) const;
+    SideWidgetLocation findSideWidget(const QGuiAction *a) const;
 
     SideWidgetEntryList leadingSideWidgets;
     SideWidgetEntryList trailingSideWidgets;
diff --git a/src/widgets/widgets/qmenu.cpp b/src/widgets/widgets/qmenu.cpp
index 72653b377d..975f4f0e51 100644
--- a/src/widgets/widgets/qmenu.cpp
+++ b/src/widgets/widgets/qmenu.cpp
@@ -159,10 +159,11 @@ public:
         Q_D(QTornOffMenu);
         if(menu != d->causedMenu)
             return;
+        auto action = static_cast<QAction *>(act->action());
         if (act->type() == QEvent::ActionAdded) {
-            insertAction(act->before(), act->action());
+            insertAction(static_cast<QAction *>(act->before()), action);
         } else if (act->type() == QEvent::ActionRemoved)
-            removeAction(act->action());
+            removeAction(action);
     }
     void actionEvent(QActionEvent *e) override
     {
@@ -3540,15 +3541,16 @@ void QMenu::actionEvent(QActionEvent *e)
                 wa->releaseWidget(widget);
             }
         }
-        d->widgetItems.remove(e->action());
+        d->widgetItems.remove(static_cast<QAction *>(e->action()));
     }
 
     if (!d->platformMenu.isNull()) {
+        auto action = static_cast<QAction *>(e->action());
         if (e->type() == QEvent::ActionAdded) {
             QPlatformMenuItem *beforeItem = e->before()
                 ? d->platformMenu->menuItemForTag(reinterpret_cast<quintptr>(e->before()))
                 : nullptr;
-            d->insertActionInPlatformMenu(e->action(), beforeItem);
+            d->insertActionInPlatformMenu(action, beforeItem);
         } else if (e->type() == QEvent::ActionRemoved) {
             QPlatformMenuItem *menuItem = d->platformMenu->menuItemForTag(reinterpret_cast<quintptr>(e->action()));
             d->platformMenu->removeMenuItem(menuItem);
@@ -3556,7 +3558,7 @@ void QMenu::actionEvent(QActionEvent *e)
         } else if (e->type() == QEvent::ActionChanged) {
             QPlatformMenuItem *menuItem = d->platformMenu->menuItemForTag(reinterpret_cast<quintptr>(e->action()));
             if (menuItem) {
-                d->copyActionToPlatformItem(e->action(), menuItem);
+                d->copyActionToPlatformItem(action, menuItem);
                 d->platformMenu->syncMenuItem(menuItem);
             }
         }
diff --git a/src/widgets/widgets/qmenubar.cpp b/src/widgets/widgets/qmenubar.cpp
index 3d31a3b73a..2ababac7a4 100644
--- a/src/widgets/widgets/qmenubar.cpp
+++ b/src/widgets/widgets/qmenubar.cpp
@@ -1293,21 +1293,22 @@ void QMenuBar::actionEvent(QActionEvent *e)
         if (!nativeMenuBar)
             return;
 
+        auto action = static_cast<QAction *>(e->action());
         if (e->type() == QEvent::ActionAdded) {
-            QPlatformMenu *menu = d->getPlatformMenu(e->action());
+            QPlatformMenu *menu = d->getPlatformMenu(action);
             if (menu) {
-                d->copyActionToPlatformMenu(e->action(), menu);
+                d->copyActionToPlatformMenu(action, menu);
 
-                QPlatformMenu *beforeMenu = d->findInsertionPlatformMenu(e->action());
+                QPlatformMenu *beforeMenu = d->findInsertionPlatformMenu(action);
                 d->platformMenuBar->insertMenu(menu, beforeMenu);
             }
         } else if (e->type() == QEvent::ActionRemoved) {
-            QPlatformMenu *menu = d->getPlatformMenu(e->action());
+            QPlatformMenu *menu = d->getPlatformMenu(action);
             if (menu)
                 d->platformMenuBar->removeMenu(menu);
         } else if (e->type() == QEvent::ActionChanged) {
             QPlatformMenu *cur = d->platformMenuBar->menuForTag(reinterpret_cast<quintptr>(e->action()));
-            QPlatformMenu *menu = d->getPlatformMenu(e->action());
+            QPlatformMenu *menu = d->getPlatformMenu(action);
 
             // the menu associated with the action can change, need to
             // remove and/or insert the new platform menu
@@ -1315,13 +1316,13 @@ void QMenuBar::actionEvent(QActionEvent *e)
                 if (cur)
                     d->platformMenuBar->removeMenu(cur);
                 if (menu) {
-                    d->copyActionToPlatformMenu(e->action(), menu);
+                    d->copyActionToPlatformMenu(action, menu);
 
-                    QPlatformMenu *beforeMenu = d->findInsertionPlatformMenu(e->action());
+                    QPlatformMenu *beforeMenu = d->findInsertionPlatformMenu(action);
                     d->platformMenuBar->insertMenu(menu, beforeMenu);
                 }
             } else if (menu) {
-                d->copyActionToPlatformMenu(e->action(), menu);
+                d->copyActionToPlatformMenu(action, menu);
                 d->platformMenuBar->syncMenu(menu);
             }
         }
diff --git a/src/widgets/widgets/qtoolbar.cpp b/src/widgets/widgets/qtoolbar.cpp
index fcaafbc581..aa8d2457d9 100644
--- a/src/widgets/widgets/qtoolbar.cpp
+++ b/src/widgets/widgets/qtoolbar.cpp
@@ -967,7 +967,7 @@ QAction *QToolBar::actionAt(const QPoint &p) const
 void QToolBar::actionEvent(QActionEvent *event)
 {
     Q_D(QToolBar);
-    QAction *action = event->action();
+    auto action = static_cast<QAction *>(event->action());
     QWidgetAction *widgetAction = qobject_cast<QWidgetAction *>(action);
 
     switch (event->type()) {
diff --git a/src/widgets/widgets/qtoolbarlayout.cpp b/src/widgets/widgets/qtoolbarlayout.cpp
index d50e19a5ed..31cb18efbd 100644
--- a/src/widgets/widgets/qtoolbarlayout.cpp
+++ b/src/widgets/widgets/qtoolbarlayout.cpp
@@ -207,7 +207,7 @@ void QToolBarLayout::insertAction(int index, QAction *action)
     }
 }
 
-int QToolBarLayout::indexOf(QAction *action) const
+int QToolBarLayout::indexOf(const QGuiAction *action) const
 {
     for (int i = 0; i < items.count(); ++i) {
         if (items.at(i)->action == action)
diff --git a/src/widgets/widgets/qtoolbarlayout_p.h b/src/widgets/widgets/qtoolbarlayout_p.h
index b5dc121b93..1a406a3d29 100644
--- a/src/widgets/widgets/qtoolbarlayout_p.h
+++ b/src/widgets/widgets/qtoolbarlayout_p.h
@@ -96,7 +96,7 @@ public:
     QSize sizeHint() const override;
 
     void insertAction(int index, QAction *action);
-    int indexOf(QAction *action) const;
+    int indexOf(const QGuiAction *action) const;
     using QLayout::indexOf; // bring back the hidden members
 
     bool layoutActions(const QSize &size);
diff --git a/src/widgets/widgets/qtoolbutton.cpp b/src/widgets/widgets/qtoolbutton.cpp
index b00b219386..cced36738c 100644
--- a/src/widgets/widgets/qtoolbutton.cpp
+++ b/src/widgets/widgets/qtoolbutton.cpp
@@ -466,7 +466,7 @@ void QToolButton::paintEvent(QPaintEvent *)
 void QToolButton::actionEvent(QActionEvent *event)
 {
     Q_D(QToolButton);
-    QAction *action = event->action();
+    auto action = static_cast<QAction *>(event->action());
     switch (event->type()) {
     case QEvent::ActionChanged:
         if (action == d->defaultAction)
diff --git a/tests/auto/widgets/kernel/qaction/tst_qaction.cpp b/tests/auto/widgets/kernel/qaction/tst_qaction.cpp
index 0d62c2cd4b..0d45bbc749 100644
--- a/tests/auto/widgets/kernel/qaction/tst_qaction.cpp
+++ b/tests/auto/widgets/kernel/qaction/tst_qaction.cpp
@@ -72,7 +72,7 @@ private slots:
 private:
     QEvent::Type m_lastEventType;
     const int m_keyboardScheme;
-    QAction *m_lastAction;
+    QGuiAction *m_lastAction;
 };
 
 tst_QAction::tst_QAction()
diff --git a/tests/auto/widgets/kernel/qactiongroup/tst_qactiongroup.cpp b/tests/auto/widgets/kernel/qactiongroup/tst_qactiongroup.cpp
index 524040d003..ae2b00c63a 100644
--- a/tests/auto/widgets/kernel/qactiongroup/tst_qactiongroup.cpp
+++ b/tests/auto/widgets/kernel/qactiongroup/tst_qactiongroup.cpp
@@ -259,7 +259,7 @@ void tst_QActionGroup::unCheckCurrentAction()
     action1.setChecked(true);
     QVERIFY(action1.isChecked());
     QVERIFY(!action2.isChecked());
-    QAction *current = group.checkedAction();
+    auto current = group.checkedAction();
     QCOMPARE(current, &action1);
     current->setChecked(false);
     QVERIFY(!action1.isChecked());
-- 
2.17.1

